CREATE TABLE user(
id INT PRIMARY KEY auto_increment,
user VARCHAR(50)  not null unique,
pass VARCHAR (8) not null
);

CREATE TABLE userData(
id INT PRIMARY KEY auto_increment,
user INT,
name VARCHAR (50) ,
secondName VARCHAR (50),
age int,
date date,
vip boolean,
FOREIGN KEY (user) references User (id)
);

CREATE TABLE ComponentType(
id INT PRIMARY KEY auto_increment,
typeName VARCHAR (50)
);

CREATE TABLE Component(
id INT PRIMARY KEY auto_increment,
ref VARCHAR(10) ,
type INT,
description VARCHAR (255),
brand varchar(20),
model varchar(20),
price double ,
FOREIGN KEY (type) references ComponentType (id)
);

CREATE TABLE PersonalComputer(
id INT PRIMARY KEY auto_increment,
ref VARCHAR(10) ,
description VARCHAR (255),
brand varchar(20),
model varchar(20),
price double not null
);

CREATE TABLE PersonalComputerComponent(
personalcomputer_id INT not null,
component_id INT not null ,
FOREIGN KEY (component_id) references Component (id),
FOREIGN KEY (personalcomputer_id) references PersonalComputer (id)
);

CREATE TABLE address(
id INT PRIMARY KEY auto_increment,
country VARCHAR (50) not null,
City VARCHAR (50) not null,
address VARCHAR (255) not null,
PostalCode INT
);

CREATE TABLE purchaseorder(
id INT PRIMARY KEY auto_increment,
user INT,
adress INT,
date date,
coments VARCHAR (255),
totalPrice double not null,
FOREIGN KEY (user) references user (id),
FOREIGN KEY (adress) references address (id)
);

CREATE TABLE stateorder(
id INT PRIMARY KEY auto_increment,
purchaseorder INT,
statDescription VARCHAR (255),
date date,
FOREIGN KEY (purchaseorder) references purchaseorder (id)
);

CREATE TABLE OrderPersonalComputer(
purchaseorder_id INT not null ,
personalcomputer_id INT not null,
FOREIGN KEY (purchaseorder_id) references purchaseorder (id),
FOREIGN KEY (personalcomputer_id) references PersonalComputer (id)
);


