package edu.uoc.prototip.model;

import java.util.List;

import javax.persistence.CascadeType;
import javax.persistence.Column;
import javax.persistence.Entity;
import javax.persistence.GeneratedValue;
import javax.persistence.GenerationType;
import javax.persistence.Id;
import javax.persistence.JoinColumn;
import javax.persistence.ManyToMany;
import javax.persistence.ManyToOne;
import javax.persistence.Table;

@Entity
@Table
public class Component {

	@Id
	@GeneratedValue(strategy = GenerationType.IDENTITY) 	
	private int id;

	@Column(length=10,nullable=false,unique=true)
	private String ref;
	
	@Column(length=255)
	private String description;
	
	@Column(length=20)
	private String brand;
	
	@Column(length=20)
	private String model;
	
	@Column(nullable=false)
	private double price;
	
	@ManyToOne(cascade=CascadeType.ALL, optional=true)
	@JoinColumn(name="type")
	private ComponentType type;
	
	@ManyToMany(mappedBy = "components")
	private List<PersonalComputer> personalComputer;

	public int getId() {
		return id;
	}

	public void setId(int id) {
		this.id = id;
	}

	public String getRef() {
		return ref;
	}

	public void setRef(String ref) {
		this.ref = ref;
	}

	public String getDescription() {
		return description;
	}

	public void setDescription(String description) {
		this.description = description;
	}

	public String getBrand() {
		return brand;
	}

	public void setBrand(String brand) {
		this.brand = brand;
	}

	public String getModel() {
		return model;
	}

	public void setModel(String model) {
		this.model = model;
	}

	public double getPrice() {
		return price;
	}

	public void setPrice(double price) {
		this.price = price;
	}

	public ComponentType getType() {
		return type;
	}

	public void setType(ComponentType type) {
		this.type = type;
	}

	public List<PersonalComputer> getPersonalComputer() {
		return personalComputer;
	}

	public void setPersonalComputer(List<PersonalComputer> personalComputer) {
		this.personalComputer = personalComputer;
	}

	@Override
	public String toString() {
		return "Component [id=" + id + ", ref=" + ref + ", description="
				+ description + ", brand=" + brand + ", model=" + model
				+ ", price=" + price + ", type=" + type + ", personalComputer="
				+ personalComputer + "]";
	}
}
