package edu.uoc.prototip.model;

import java.util.List;

import javax.persistence.CascadeType;
import javax.persistence.Column;
import javax.persistence.Entity;
import javax.persistence.GeneratedValue;
import javax.persistence.GenerationType;
import javax.persistence.Id;
import javax.persistence.JoinColumn;
import javax.persistence.JoinTable;
import javax.persistence.ManyToMany;
import javax.persistence.Table;

import edu.uoc.prototip.model.Purchaseorder;

@Entity
@Table
public class PersonalComputer {

	@Id
	@GeneratedValue(strategy = GenerationType.IDENTITY) 	
	private int id;

	@Column(length=10,nullable=false,unique=true)
	private String ref;
	
	@Column(length=255)
	private String description;
	
	@Column(length=20)
	private String brand;
	
	@Column(length=20)
	private String model;
	
	@Column(nullable=false)
	private double price;
	
	@ManyToMany(cascade=CascadeType.ALL)
	@JoinTable(name="PersonalComputerComponent",
    joinColumns={
        @JoinColumn(name="personalcomputer_id", referencedColumnName="ID")},
    inverseJoinColumns=
        @JoinColumn(name="component_id", referencedColumnName="ID")
    )
	private List<Component> components;

	@ManyToMany(mappedBy = "product")
	private List<Purchaseorder> purchaseorder;
	
	public int getId() {
		return id;
	}

	public void setId(int id) {
		this.id = id;
	}

	public String getRef() {
		return ref;
	}

	public void setRef(String ref) {
		this.ref = ref;
	}

	public String getDescription() {
		return description;
	}

	public void setDescription(String description) {
		this.description = description;
	}

	public String getBrand() {
		return brand;
	}

	public void setBrand(String brand) {
		this.brand = brand;
	}

	public String getModel() {
		return model;
	}

	public void setModel(String model) {
		this.model = model;
	}

	public double getPrice() {
		return price;
	}

	public void setPrice(double price) {
		this.price = price;
	}

	public List<Component> getComponents() {
		return components;
	}

	public void setComponents(List<Component> components) {
		this.components = components;
	}

	public List<Purchaseorder> getPurchaseorder() {
		return purchaseorder;
	}

	public void setPurchaseorder(List<Purchaseorder> purchaseorder) {
		this.purchaseorder = purchaseorder;
	}

	@Override
	public String toString() {
		return "PersonalComputer [id=" + id + ", ref=" + ref + ", description="
				+ description + ", brand=" + brand + ", model=" + model
				+ ", price=" + price + ", components=" + components
				+ ", purchaseorder=" + purchaseorder + "]";
	}	
}
