package edu.uoc.prototip.model;

import java.sql.Date;
import java.util.List;

import javax.persistence.CascadeType;
import javax.persistence.Column;
import javax.persistence.Entity;
import javax.persistence.GeneratedValue;
import javax.persistence.GenerationType;
import javax.persistence.Id;
import javax.persistence.JoinColumn;
import javax.persistence.JoinTable;
import javax.persistence.ManyToMany;
import javax.persistence.ManyToOne;
import javax.persistence.OneToMany;
import javax.persistence.OneToOne;
import javax.persistence.Table;

@Entity
@Table
public class Purchaseorder {

	@Id
	@GeneratedValue(strategy = GenerationType.IDENTITY) 	
	private int id;

	@ManyToOne(cascade=CascadeType.ALL, optional=true)
	@JoinColumn(name="user")
	private User user;
	
	@OneToOne(cascade = CascadeType.ALL, optional=true)
	@JoinColumn(name="adress")
	private Address adress;
	
	private Date date;
	
	private String coments;
	
	@Column(nullable=false)
	private double totalPrice;
	
	@OneToMany(mappedBy="purchaseorder")
	private List<StateOrder> state;
	
	@ManyToMany(cascade=CascadeType.ALL)
	@JoinTable(name="OrderPersonalComputer",
    joinColumns={
        @JoinColumn(name="purchaseorder_id", referencedColumnName="ID")},
    inverseJoinColumns=
        @JoinColumn(name="personalcomputer_id", referencedColumnName="ID")
    )
	private List<PersonalComputer> product;

	public int getId() {
		return id;
	}

	public void setId(int id) {
		this.id = id;
	}

	public User getUser() {
		return user;
	}

	public void setUser(User user) {
		this.user = user;
	}

	public Address getAdress() {
		return adress;
	}

	public void setAdress(Address adress) {
		this.adress = adress;
	}

	public Date getDate() {
		return date;
	}

	public void setDate(Date date) {
		this.date = date;
	}

	public String getComents() {
		return coments;
	}

	public void setComents(String coments) {
		this.coments = coments;
	}

	public double getTotalPrice() {
		return totalPrice;
	}

	public void setTotalPrice(double totalPrice) {
		this.totalPrice = totalPrice;
	}

	public List<StateOrder> getState() {
		return state;
	}

	public void setState(List<StateOrder> state) {
		this.state = state;
	}

	public List<PersonalComputer> getProduct() {
		return product;
	}

	public void setProduct(List<PersonalComputer> product) {
		this.product = product;
	}

	@Override
	public String toString() {
		return "Purchaseorder [id=" + id + ", user=" + user + ", adress="
				+ adress + ", date=" + date + ", coments=" + coments
				+ ", totalPrice=" + totalPrice + ", state=" + state
				+ ", product=" + product + "]";
	}

}
