package edu.uoc.prototip.model;

import javax.persistence.Column;
import javax.persistence.Entity;
import javax.persistence.GeneratedValue;
import javax.persistence.GenerationType;
import javax.persistence.Id;
import javax.persistence.OneToOne;
import javax.persistence.Table;

@Entity
@Table
public class User {

	@Id
	@GeneratedValue(strategy = GenerationType.IDENTITY) 	
	private int id;

	@Column(length=50,nullable=false,unique=true)
	private String user;
	
	@Column(length=8,nullable=false)
	private String pass;
	
	@OneToOne(mappedBy="user")
	private UserData userData;
	
	public User(int id, String user, String pass) {
		this.id = id;
		this.user = user;
		this.pass = pass;
	}
	
	public User(String user, String pass) {
		this.user = user;
		this.pass = pass;
	}
	
	public User() {
		super();
	}

	public int getId() {
		return id;
	}

	public void setId(int id) {
		this.id = id;
	}

	public String getUser() {
		return user;
	}

	public void setUser(String user) {
		this.user = user;
	}

	public String getPass() {
		return pass;
	}

	public void setPass(String pass) {
		this.pass = pass;
	}

	public UserData getUserData() {
		return userData;
	}

	public void setUserData(UserData userData) {
		this.userData = userData;
	}

	@Override
	public String toString() {
		return "User [id=" + id + ", user=" + user + ", pass=" + pass + "]";
	}

	
}
